package com.four.patient.service.Impl;

import com.four.common.core.domain.R;
import com.four.common.duck.domain.GiftRecord;
import com.four.common.duck.gift.Gift;
import com.four.common.security.utils.SecurityUtils;
import com.four.patient.feign.DoctorFeign;
import com.four.patient.mapper.GiftMapper;
import com.four.patient.service.GiftService;
import com.four.system.api.domain.SysDoctor;
import com.four.system.api.domain.SysUser;
import com.four.system.api.model.LoginUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Service
public class GiftServiceImpl implements GiftService {

    @Autowired
    private GiftMapper giftMapper;
    @Autowired
    private DoctorFeign doctorFeign;

    @Override
    public List<Gift> ShowGiftAll() {
        List<Gift> gifts=giftMapper.ShowGiftAll();
        return gifts;
    }
    @Transactional
    @Override
    public Integer insertGiftLog(GiftRecord giftRecord) {
        Integer i=giftMapper.insertGiftLog(giftRecord);
        if (i<0){
            return null;
        }
        LoginUser loginUser = SecurityUtils.getLoginUser();
        //获取患者id
        Long userid = loginUser.getUserid();
        giftRecord.setGiverId(userid);
        giftRecord.setGiftGivingTime(new Date());
        //获取患者余额
        R<SysUser> sysUser = doctorFeign.findByUserId(userid);
        SysUser userData = sysUser.getData();
        double userMoney = userData.getUserMoney().doubleValue();
        Gift gift=giftMapper.findByGiftId(giftRecord.getGiftId());
        //获取礼物价格
        double giftPrice = gift.getGiftPrice().doubleValue();
        BigDecimal patientMoney=BigDecimal.valueOf(userMoney-giftPrice);
        doctorFeign.updateSysUserMoney(userid,patientMoney);
        //获取医生用户信息
        R<SysDoctor> registrationInfoUser = doctorFeign.findRegistrationInfoUserId(giftRecord.getRegistrationInformationId());
        //获取医生用户
        SysDoctor sysDoctor = registrationInfoUser.getData();
        R<SysUser> User = doctorFeign.findByUserId(sysDoctor.getUserId());
        SysUser user = User.getData();
        //修改医生金额
        double doctorMoney = (user.getUserMoney().doubleValue() + giftPrice);
        doctorFeign.updateSysUserMoney(user.getUserId(),BigDecimal.valueOf(doctorMoney));
        return i;
    }
}
