package com.four.patient.service.Impl;

import com.alibaba.fastjson.JSONObject;
import com.four.common.core.web.domain.AjaxResult;
import com.four.common.duck.Result;
import com.four.common.duck.communitypatients.SymptomsDrugs;
import com.four.patient.feign.DoctorFeign;
import com.four.patient.feign.SymptomDrugsFeign;
import com.four.patient.service.RegistrationInformationService;
import com.four.system.api.domain.SysDoctor;
import com.four.system.api.domain.SysRegistrationInformation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.util.Collections;
import java.util.List;

@Service
public class RegistrationInformationServiceImpl implements RegistrationInformationService {

    @Autowired
    private DoctorFeign doctorFeign;

    @Autowired
    private SymptomDrugsFeign symptomDrugsFeign;


    @Override
    public List<SysDoctor> ShowRegistrationInformationNumber(Long medicalDepartmentId) {
        AjaxResult doctorPraise = doctorFeign.findDoctorPraise(medicalDepartmentId);
        Object o = doctorPraise.get("sysList");
        List<SysDoctor> sysDoctorList = Collections.singletonList(JSONObject.parseObject(o.toString(), SysDoctor.class));
        return sysDoctorList;
    }

    @Override
    public List<SysDoctor> ShowRegistrationInformationPraise(Long medicalDepartmentId) {
        AjaxResult doctorNumber = doctorFeign.findDoctorNumber(medicalDepartmentId);
        Object o = doctorNumber.get("sysUser");
        List<SysDoctor> sysDoctorList = Collections.singletonList(JSONObject.parseObject(o.toString(), SysDoctor.class));
        return sysDoctorList;
    }

    @Override
    public List<SysDoctor> ShowRegistrationInformationAll(Long medicalDepartmentId) {
        AjaxResult doctorComprehensive = doctorFeign.findDoctorComprehensive(medicalDepartmentId);
        Object o = doctorComprehensive.get("sysDoctorList");
        List<SysDoctor> sysDoctorList = Collections.singletonList(JSONObject.parseObject(o.toString(), SysDoctor.class));
        return sysDoctorList;
    }

    @Override
    public List<SymptomsDrugs> ShowSymptomsDrug() {
        Result<List<SymptomsDrugs>> symptomDrugsAll = symptomDrugsFeign.findSymptomDrugsAll();
        List<SymptomsDrugs> symptomsDrugsList=symptomDrugsAll.getData();
        return symptomsDrugsList;
    }

    @Override
    public SysRegistrationInformation ShowRegistration(Long registrationInformationId) {
        AjaxResult registrationInformation = doctorFeign.findRegistrationInformation(registrationInformationId);
        Object o = registrationInformation.get("registrationInformation");
        SysRegistrationInformation sysRegistrationInformation = JSONObject.parseObject(o.toString(), SysRegistrationInformation.class);
        return sysRegistrationInformation;
    }

    @Override
    public List<SysDoctor> ShowRegistrationInformationAllPrice(Long medicalDepartmentId) {
        AjaxResult ajaxResult = doctorFeign.findDoctorInformation(medicalDepartmentId);
        Object sysRedis = ajaxResult.get("sysRedis");
        List<SysDoctor> sysDoctorList = Collections.singletonList(JSONObject.parseObject(sysRedis.toString(), SysDoctor.class));
        return sysDoctorList;
    }


}
